;******************************************************************************
;*  FUNCTION	mul16x8_24.inc
;*  Mutiply 	16x8 -> 24 bit 		(unsigned * unsigned)
;*
;* 		AH  AL    BL     E2 E1 E0
;*  	R21:R20 x R16 -> R4:R3:R2
;*	
;*	Scrached Register:	-
;*  10 cycles + 4 (RET) = 14 Cycles
;*
;******************************************************************************
mul_16x8:
;   R5:R2 = R17:R16 * R21:R20

		mul 	R20,R16					; AL * BL
		movw 	R3:R2,R1:R0
		clr		R4
		mul 	R21,R16					; AH * BL
		add		R3,R0
		adc		R4,R1
		ret
