;******************************************************************************
;*  FUNCTION	muls16x8_24.inc
;*  Mutiply 	16x8 -> 24 bit 		(signed * signed)
;*
;* 		AH  AL    BL     E2 E1 E0
;*  	R21:R20 x R16 -> R4:R3:R2
;*	
;*	Scrached Register:	-
;*  11 cycles + 4 (RET) = 15 Cycles
;*
;******************************************************************************
muls_16x8:
		push	R10
		sub		R10,R10			; NULL
		sub		R4,R4
		mulsu	R16,R20			; BL*AL	(s*u)
		sbc		R4,R10
		movw	R3:R2,R1:R0
		muls	R21,R16			; AH*BL	(s*s)		
		add		R3,R0
		adc		R4,R1
		pop		R10
		ret
