;******************************************************************************
;*  FUNCTION	mulsu16x8_24.inc
;*  Mutiply 	16x8 -> 24 bit 		(signed * unsigned)
;*
;* 		AH  AL    BL     E2 E1 E0
;*  	R21:R20 x R16 -> R4:R3:R2
;*	
;*	Scrached Register:	-
;*  16 cycles + 4 (RET) = 20 Cycles
;*
;******************************************************************************
mulsu_16x8:
		push	R10
		sub		R10,R10			; NULL
		clr		R4				
		mul		R20,R16			; AL x BL		(u*u)		
		movw	R3:R2,R1:R0
		adc		R4,R10
		mulsu	R21,R16			; AH x BL		(s*u)
		sbc		R4,R10		
		add		R3,R0
		adc		R4,R1
		pop		R10
		ret
