;***********************************************************************************
;*
;*		FUNCTION	mulsu24x8_32.inc
;*		Mutiply 	24x8 -> 32 bit			(signed * unsigned)
;*
;*      AH  AM  AL    BL     E3 E2 E1 E0
;*      R22:R21:R20 x R16 -> R5:R4:R3:R2
;*
;*  17 cycles + 4 (RET) = 21 Cycles
;*
;***********************************************************************************
mulsu_24x8:
		push	R10
		sub		R10,R10		
		mul		R20,R16			; AL x BL
		movw	R3:R2,R1:R0
		mulsu	R22,R16			; AH x BL
		movw	R5:R4,R1:R0	
		mul		R21,R16			; AM x BL				
		add		R3,R0
		adc		R4,R1
		adc		R5,R10
		pop		R10
		ret